"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Store = /** @class */ (function () {
    function Store() {
        this.subscribers = [];
        this.state = {};
    }
    Store.prototype.setState = function (state) {
        this.state = Object.assign({}, this.state, state);
        this.dispatch();
    };
    Store.prototype.subscribe = function (listener) {
        var _this = this;
        this.subscribers.push(listener);
        var isSubscribed = true;
        return function () {
            if (!isSubscribed) {
                return;
            }
            isSubscribed = false;
            var index = _this.subscribers.indexOf(listener);
            _this.subscribers.splice(index, 1);
        };
    };
    Store.prototype.dispatch = function () {
        this.subscribers.forEach(function (listener) { return listener(); });
    };
    return Store;
}());
exports.Store = Store;
//# sourceMappingURL=Store.js.map