import * as React from "react";
import { MapStoresToProps, StoreMap, Unsubscribe } from "./types";
import { Store } from "./Store";
export declare function connect<TInjectedProps, TAllProps extends TInjectedProps>(mapStoresToProps: MapStoresToProps<TInjectedProps>, Cmp: React.ComponentType<TAllProps | {}>): {
    new (props: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>): {
        subscribedStores: {
            [storeName: string]: Unsubscribe;
        };
        render(): JSX.Element;
        componentWillUnmount(): void;
        subscribeToStore(name: string, store: Store<{}>): void;
        withAutoSubscribers(stores: StoreMap): StoreMap;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>, context?: any): {
        subscribedStores: {
            [storeName: string]: Unsubscribe;
        };
        render(): JSX.Element;
        componentWillUnmount(): void;
        subscribeToStore(name: string, store: Store<{}>): void;
        withAutoSubscribers(stores: StoreMap): StoreMap;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<Pick<TAllProps, Exclude<keyof TAllProps, keyof TInjectedProps>>>, nextState: Readonly<{}>, nextContext: any): void;
    };
    displayName: string;
    contextType: React.Context<{}>;
};
