"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var container_1 = require("./container");
function connect(mapStoresToProps, Cmp) {
    var _a;
    return _a = /** @class */ (function (_super) {
            __extends(ConnectedComponent, _super);
            function ConnectedComponent() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.subscribedStores = {};
                return _this;
            }
            ConnectedComponent.prototype.render = function () {
                var allStores = this.withAutoSubscribers(this.context);
                return React.createElement(Cmp, __assign({}, mapStoresToProps(allStores), this.props));
            };
            ConnectedComponent.prototype.componentWillUnmount = function () {
                Object.values(this.subscribedStores).forEach(function (u) { return u(); });
            };
            ConnectedComponent.prototype.subscribeToStore = function (name, store) {
                var _this = this;
                var unsubscribe = store.subscribe(function () {
                    _this.forceUpdate();
                });
                this.subscribedStores[name] = unsubscribe;
            };
            ConnectedComponent.prototype.withAutoSubscribers = function (stores) {
                var _this = this;
                var watchedStores = {};
                Object.keys(stores).forEach(function (key) {
                    Object.defineProperty(watchedStores, key, {
                        get: function () {
                            if (!_this.subscribedStores[key]) {
                                _this.subscribeToStore(key, stores[key]);
                                _this.subscribedStores[key];
                            }
                            return stores[key];
                        }
                    });
                });
                return watchedStores;
            };
            return ConnectedComponent;
        }(React.PureComponent)),
        _a.displayName = "Connect(" + (Cmp.name || Cmp.displayName) + ")",
        _a.contextType = container_1.ContainerContext,
        _a;
}
exports.connect = connect;
//# sourceMappingURL=connect.js.map